#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int n = inf.readInt(1, 100'000, "n");
    inf.readEoln();
    inf.readInts(n, 1, 100'000, "a");
    inf.readEoln();
    int q = inf.readInt(1, 100'000, "~q");
    inf.readEoln();
    for (int j = 0; j < q; ++j) {
        int tp = inf.readInt(1, 3, "t");
        inf.readSpace();
        int l;
        switch(tp) {
        case 1:
        case 2:
            inf.readInt(2, 100'000, "k");
            break;
        case 3:
            l = inf.readInt(1, n, "l");
            inf.readSpace();
            inf.readInt(l, n, "r");
        }
        inf.readEoln();
    }
    inf.readEof();
}